.386

Code segment word public "CODE"
       	assume cs:Code , ds:nothing

mystack segment para stack "STACK"
	db 512 dup(?)
mystack ends

BASE_8253 	equ 40h
TIMER_0_8253 	equ BASE_8253 + 0
MODE_8253	equ BASE_8253 + 3

OCW3	equ	20h
IRR	equ	20h

MPOPF macro
	local p1,p2
	jmp short p2
p1: iret
p2: push cs
	call p1
	endm

DELAY macro
	jmp $+2
	jmp $+2
	jmp $+2
	endm 

OutputStr	label byte
	db 0dh, 0ah, "Timed count: ",5 dup(?)

ASCIICountEnd	label byte
	db "x 10*-6 sec",0dh , 0ah
	db "$"

OutputStr_1	label byte
	db 0dh, 0ah, "Average timed count: ",5 dup(?)

ASCIICountEnd_1	label byte
	db "x 10*-7 sec",0dh , 0ah
	db "$"

OutputStr_2	label byte
	db 0dh, 0ah, "Approximate Memory bandwidth: ",5 dup(?)

ASCIICountEnd_2	label byte
	db "x 10*7 bytes/sec",0dh , 0ah
	db "$"

OriginalFlags	db	?
TimedCount	dw	?
ReferenceCount	dw	?
memvar		dw	?

start:
	mov di,0
	mov bp,10
Begin:
	dec bp
	call Process
	cmp bp,0
	jne Begin

	mov ax,di
	
	mov bx,10
	mov cx,5
	mov esi,offset ASCIICountEnd_1 - 1

CTSLoop_1:
	sub dx,dx
	div bx
	add dl,"0"
	mov [si],dl
	dec si
	loop CTSLoop_1

	mov ah,9
	mov edx,offset OutputStr_1
	int 21h

;;;mem BW

	mov esi,offset ASCIICountEnd_2 - 1
	sub dx,dx
	mov eax,1000000
	mov bx,di
	div bx

	mov cx,5
	mov bx,10
CTSLoop_2:
	sub dx,dx
	div bx
	add dl,"0"
	mov [si],dl
	dec si
	loop CTSLoop_2

	mov ah,9
	mov edx,offset OutputStr_2
	int 21h
		
	
	mov ah,4Ch
	int 21h

Process proc near
	push cs
	pop ds

	call ZTimerOn

        rept 1000000
	mov ax,[memvar]
	endm

	call ZTimerOff

	call ZTimerReport
Process endp
	

ZTimerOn proc near

	push eax
	pushf
	pop eax

	mov cs:[OriginalFlags], ah
	and ah,0fdh

	push eax

	sti

	mov al,00110100b
	out MODE_8253,al

	DELAY
	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	rept 10
	jmp $+2
	endm

	cli
	
	mov al,00110100b
	out MODE_8253,al
	DELAY
	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	MPOPF

	pop eax
	ret

ZTimerOn endp

ZTimerOff proc near

	push eax
	push ecx
	pushf

	mov al,00000000b
	out MODE_8253,al

	in al,TIMER_0_8253
	DELAY
	mov ah,al
	in al,TIMER_0_8253
	xchg ah,al
	neg ax
	mov cs:[TimedCount],ax

	mov cs:[ReferenceCount],0
	mov ecx,16
	cli

RefLoop:
	call ReferenceZTimerOn
	call ReferenceZTimerOff
	loop RefLoop
	sti
	add cs:[ReferenceCount],8
	mov cl,4
	shr cs:[ReferenceCount],cl

	pop ax

	mov ch,cs:[OriginalFlags]
	and ch,not 0fdh
	and ah,0fdh
	or  ah,ch
	push ax

	MPOPF

	pop cx
	pop ax
	ret

ZTimerOff endp

ReferenceZTimerOn proc near

	push eax
	pushf

	mov al,00110100b
	out MODE_8253,al
	DELAY

	sub al,al
	out TIMER_0_8253,al
	DELAY
	out TIMER_0_8253,al

	MPOPF

	pop eax
	ret

ReferenceZTimerOn endp

ReferenceZTimerOff proc near

	push eax
	push ecx
	pushf

	mov al,00000000b
	out MODE_8253,al
	DELAY
	in al,TIMER_0_8253
	DELAY
	mov ah,al
	in al,TIMER_0_8253
	xchg ah,al
	neg ax
	add cs:[ReferenceCount],ax

	MPOPF
	pop ecx
	pop eax
	ret

ReferenceZTimerOff endp

ZTimerReport proc near

	pushf
	push eax
	push ebx
	push ecx
	push edx
	push esi
	push ds

	push cs
	pop ds
	assume ds:Code

	mov ax,[TimedCount]
	sub ax,[ReferenceCount]
	mov esi,offset ASCIICountEnd - 1

	mov edx,8381
	mul edx
	mov ebx,10000
	div ebx

	push eax
	mov ebx,edi
	adc eax,ebx
	mov edi,eax
	pop eax

	mov ebx,10
	mov ecx,5

CTSLoop:
	sub edx,edx
	div ebx
	add dl,"0"
	mov [si],dl
	dec esi
	loop CTSLoop

	mov ah,9
	mov edx,offset OutputStr
	int 21h

	pop ds
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax
	MPOPF
	ret

ZTimerReport endp

Code ends
	end start	
	